/*******************************************************************************
 s3_util.h - C wrapper interface to sign S3 requests

 Copyright (C) 2020-2024 CodeShop B.V.
 http://www.code-shop.com

 For licensing see the LICENSE file
******************************************************************************/

#ifndef S3_UTIL_H_AKW
#define S3_UTIL_H_AKW

#include "mod_streaming_export.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef void (*mp4_set_header_t)(void* ctx, char const* key, char const* value);

typedef void (*mp4_set_url_t)(void* ctx, char const* url);

MP4_NODISCARD MP4_DLL_EXPORT int
mp4_add_s3_headers(void* ctx,
                   char const* url,
                   char const* secret_key,
                   char const* access_key,
                   char const* region,
                   char const* security_token,
                   mp4_set_header_t set_header,
                   mp4_set_url_t set_url,
                   char* result_text,
                   unsigned int result_size);

MP4_NODISCARD MP4_DLL_EXPORT int
mp4_add_s3_queries(void* ctx,
                   char const* url,
                   char const* secret_key,
                   char const* access_key,
                   char const* region,
                   char const* security_token,
                   mp4_set_url_t set_url,
                   char* result_text,
                   unsigned int result_size);

#ifdef __cplusplus
} /* extern C definitions */
#endif

#endif // S3_UTIL_H_AKW

// End Of File
